<?php

while (!file_exists($folder_level."config.php")) { $folder_level .= "../"; }
$fusion_root_path = realpath(dirname(__FILE__) . '/../../../') . '/';

include($fusion_root_path . 'config.php');
#######################

//$fp = fopen(realpath(dirname(__FILE__))."/debug/debug".time().".txt", "w");

class FusionCMS {

    var $userid;
    var $loginStmt;
    var $getUserStmt;
    var $getUsersStmt;

    function FusionCMS() {

      $this->loginStmt = new Statement("SELECT user_id AS id, user_name AS login, user_password, user_level FROM {$GLOBALS[db_prefix]}users WHERE user_name=? AND user_password=?");
      $this->getUserStmt = new Statement("SELECT user_id AS id, user_name AS login, user_level AS status FROM {$GLOBALS[db_prefix]}users WHERE user_id=?");
      $this->getUsersStmt = new Statement("SELECT user_id AS id, user_name as login FROM {$GLOBALS[db_prefix]}users");

      $this->userid = NULL;

      if (isset($_COOKIE['fusion_user'])) {
        $cookieValues = explode(".", $_COOKIE['fusion_user']);
        $this->userid = $cookieValues[0];

        //      fwrite($GLOBALS['fp'], "ciikies: ". print_r($_COOKIE, true));
        //      fwrite($GLOBALS['fp'], "userid: ".$this->userid);
      }

    }


    function isLoggedIn() {
        return $this->userid;
    }

    function getRoles($group) {
        $rv = NULL;

        if ($group >= 102) /* >=2 means the user is a Moderator, an Admin or a Super Admin*/
          $rv = ROLE_ADMIN;
        elseif ($GLOBALS['fc_config']['liveSupportMode'])
          $rv = ROLE_CUSTOMER;
        else /* if we branch here, the user is at least a 'Member' (user_mod >= 1) */
          $rv = ROLE_USER;

        return $rv;

    }

    function getUserProfile($userid) {

        if ($userid == SPY_USERID) $rv = NULL;

        elseif ($user = $this->getUser($userid)) {
          //$boardURL = "http://" . $_SERVER[HTTP_HOST] . "/" . fusion_root . "/";

          $boardURL = $GLOBALS[folder_level];

          $rv = ($this->isLoggedIn() == $userid) ? $boardURL . "edit_profile.php" : $boardURL . "profile.php?lookup=" . $userid;

          return $rv;
        }
    }


    function getUser($userid) {

      if ($userid == SPY_USERID) return NULL;

      $rv = NULL;


      if(($rs = $this->getUserStmt->process($userid)) && ($rec = $rs->next())) {
        $rec['roles'] = $this->getRoles($rec['status']);
        $rv = $rec;
      }
      return $rv;
    }

    function login($login, $password) {

      //      fwrite($GLOBALS['fp'], "login/password: " . $login."/".$password);

      if (($rs = $this->loginStmt->process($login, md5($password))) && ($rec = $rs->next())) {


        if ($rec['user_ban']) return NULL; /* user is banned from the site */

        $cookie_value = $rec['id'] . "." . md5($password);
        setcookie("fusion_user", $cookie_value, time() + 3600*3, "/", "", "0");

        return $rec['id'];

      }

    }

    function userInRole($userid, $role) {

        $rv = NULL;

        if($user = $this->getUser($userid)) {
            $rv = (($user['roles'] & $role) != 0);
        }

        return $rv;

    }

    function logout() {

    }

    function getUsers() {

        $rv = $this->getUsersStmt->process();
        return $rv;

        }
    }

$GLOBALS['fc_config']['db'] = array(
    'host' => $GLOBALS['db_host'],
    'user' => $GLOBALS['db_user'],
    'pass' => $GLOBALS['db_pass'],
    'base' => $GLOBALS['db_name'],
    'pref' => $GLOBALS['db_prefix']."fc_",
    );

$GLOBALS['fc_config']['cms'] = new FusionCMS();


foreach($GLOBALS['fc_config']['languages'] as $k => $v) {
    $GLOBALS['fc_config']['languages'][$k]['dialog']['login']['moderator'] = '';
}

?>